org.apache.tomcat.util.http.fileupload

## Class IOUtils

- java.lang.Object
- - org.apache.tomcat.util.http.fileupload.IOUtils

-     public class IOUtils
      extends Object

  General IO stream manipulation utilities.

  This class provides static utility methods for input/output operations.

  - closeQuietly - these methods close a stream ignoring nulls and exceptions
  - toXxx/read - these methods read data from a stream
  - write - these methods write data to a stream
  - copy - these methods copy all the data from one stream to another
  - contentEquals - these methods compare the content of two streams

  The byte-to-char methods and char-to-byte methods involve a conversion step. Two methods are provided in each case, one that uses the platform default encoding and the other which allows you to specify an encoding. You are encouraged to always specify an encoding because relying on the platform default can lead to unexpected results, for example when moving from development to production.

  All the methods in this class that read a stream are buffered internally. This means that there is no cause to use a `BufferedInputStream` or `BufferedReader`. The default buffer size of 4K has been shown to be efficient in tests.

  Wherever possible, the methods in this class do not flush or close the stream. This is to avoid making non-portable assumptions about the streams' origin and further use. Thus the caller is still responsible for closing streams after use.

  Origin of code: Excalibur.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `EOF` Represents the end-of-file (or stream).

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IOUtils()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `closeQuietly(Closeable closeable)` Closes a `Closeable` unconditionally.
    `static int` | `copy(InputStream input, OutputStream output)` Copies bytes from an `InputStream` to an `OutputStream`.
    `static long` | `copyLarge(InputStream input, OutputStream output)` Copies bytes from a large (over 2GB) `InputStream` to an `OutputStream`.
    `static int` | `read(InputStream input, byte[] buffer, int offset, int length)` Reads bytes from an input stream.
    `static void` | `readFully(InputStream input, byte[] buffer)` Reads the requested number of bytes or fail if there are not enough left.
    `static void` | `readFully(InputStream input, byte[] buffer, int offset, int length)` Reads the requested number of bytes or fail if there are not enough left.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### EOF

          public static final int EOF

      Represents the end-of-file (or stream).
      Since:
        2.5 (made public)
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### IOUtils

          public IOUtils()

  - ### Method Detail

    - #### closeQuietly

          public static void closeQuietly(Closeable closeable)

      Closes a `Closeable` unconditionally.

      Equivalent to `Closeable.close()`, except any exceptions will be ignored. This is typically used in finally blocks.

      Example code:

           Closeable closeable = null;
           try {
               closeable = new FileReader("foo.txt");
               // process closeable
               closeable.close();
           } catch (Exception e) {
               // error handling
           } finally {
               IOUtils.closeQuietly(closeable);
           }

      Closing all streams:

           try {
               return IOUtils.copy(inputStream, outputStream);
           } finally {
               IOUtils.closeQuietly(inputStream);
               IOUtils.closeQuietly(outputStream);
           }

      Parameters:
        `closeable` - the objects to close, may be null or already closed
      Since:
        2.0

    - #### copy

          public static int copy(InputStream input,
                 OutputStream output)
                          throws IOException

      Copies bytes from an `InputStream` to an `OutputStream`.

      This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

      Large streams (over 2GB) will return a bytes copied value of `-1` after the copy has completed since the correct number of bytes cannot be returned as an int. For large streams use the `copyLarge(InputStream, OutputStream)` method.

      Parameters:
        `input` - the `InputStream` to read from
        `output` - the `OutputStream` to write to
      Returns:
        the number of bytes copied, or -1 if > Integer.MAX_VALUE
      Throws:
        `NullPointerException` - if the input or output is null
        `IOException` - if an I/O error occurs
      Since:
        1.1

    - #### copyLarge

          public static long copyLarge(InputStream input,
                       OutputStream output)
                                throws IOException

      Copies bytes from a large (over 2GB) `InputStream` to an `OutputStream`.

      This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

      The buffer size is given by `DEFAULT_BUFFER_SIZE`.

      Parameters:
        `input` - the `InputStream` to read from
        `output` - the `OutputStream` to write to
      Returns:
        the number of bytes copied
      Throws:
        `NullPointerException` - if the input or output is null
        `IOException` - if an I/O error occurs
      Since:
        1.3

    - #### read

          public static int read(InputStream input,
                 byte[] buffer,
                 int offset,
                 int length)
                          throws IOException

      Reads bytes from an input stream. This implementation guarantees that it will read as many bytes as possible before giving up; this may not always be the case for subclasses of `InputStream`.
      Parameters:
        `input` - where to read input from
        `buffer` - destination
        `offset` - initial offset into buffer
        `length` - length to read, must be >= 0
      Returns:
        actual length read; may be less than requested if EOF was reached
      Throws:
        `IOException` - if a read error occurs
      Since:
        2.2

    - #### readFully

          public static void readFully(InputStream input,
                       byte[] buffer,
                       int offset,
                       int length)
                                throws IOException

      Reads the requested number of bytes or fail if there are not enough left.

      This allows for the possibility that `InputStream.read(byte[], int, int)` may not read as many bytes as requested (most likely because of reaching EOF).

      Parameters:
        `input` - where to read input from
        `buffer` - destination
        `offset` - initial offset into buffer
        `length` - length to read, must be >= 0
      Throws:
        `IOException` - if there is a problem reading the file
        `IllegalArgumentException` - if length is negative
        `EOFException` - if the number of bytes read was incorrect
      Since:
        2.2

    - #### readFully

          public static void readFully(InputStream input,
                       byte[] buffer)
                                throws IOException

      Reads the requested number of bytes or fail if there are not enough left.

      This allows for the possibility that `InputStream.read(byte[], int, int)` may not read as many bytes as requested (most likely because of reaching EOF).

      Parameters:
        `input` - where to read input from
        `buffer` - destination
      Throws:
        `IOException` - if there is a problem reading the file
        `IllegalArgumentException` - if length is negative
        `EOFException` - if the number of bytes read was incorrect
      Since:
        2.2

Copyright © 2000-2021 Apache Software Foundation. All Rights Reserved.